package com.wissamfawaz;

public class ArrayBasedStack implements Stack {
	private Object[] arr;
	private int top;
	
	public ArrayBasedStack(int capacity) {
		arr = new Object[capacity];
		top = -1;
	}

	@Override
	public int size() {
		return top + 1;
	}

	@Override
	public boolean isEmpty() {
		return size() == 0;
	}

	@Override
	public void push(Object element) throws StackException {
		if(size() == arr.length) {
			throw new StackException("Stack is full!");
		}
		
		top++;
		arr[top] = element;
	}

	@Override
	public Object pop() throws StackException {
		if(isEmpty()) {
			throw new StackException("Stack is empty!");
		}
		Object toReturn = arr[top];
		arr[top] = null;
		top--;
		return toReturn;
	}

	@Override
	public Object top() throws StackException {
		if(isEmpty()) {
			throw new StackException("Stack is empty!");
		}
		return arr[top];
	}

}
