package com.wissamfawaz;

import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

public class Main {
	private static String openingSymbols = "({[";
	private static String closingSymbols = ")}]";
	private static Map<Character, Character> matchingSymbols = new HashMap<>();
	public static void main(String[] args) throws StackException {
		String expression;
		Scanner scan = new Scanner(System.in);

		int idx = 0;
		for(char symbol : closingSymbols.toCharArray()) {
			matchingSymbols.put(symbol, openingSymbols.charAt(idx));
			idx++;
		}
		
		System.out.println("Enter an expression to validate: ");
		expression = scan.nextLine();
		
		if(validate(expression)) {
			System.out.println("Input expression is valid");
		} else {
			System.out.println("Input expression is not valid");
		}
		
		scan.close();
	}

	private static boolean validate(String expression) throws StackException {
		Stack stack = new ArrayBasedStack(expression.length());
		char current;
		
		for(int idx = 0; idx < expression.length(); idx++) {
			current= expression.charAt(idx);
			
			if(openingSymbols.indexOf(current) != -1) {
				stack.push(current);
			} else if(closingSymbols.indexOf(current) != -1) {
				if(stack.isEmpty()) {
					return false;
				}
				
			
				if(matchingSymbols.get(current) != stack.top()) {
					return false;
				}
				
				stack.pop();
				
			}
			
		}
		
		
		return stack.size() == 0;
	}
	
	
	
	
	
	
}
